From 45084e03264d0cbd773eb8cbb1795459b7d2deff Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Aug 25 2017 08:50:55 +0000
Subject: [PATCH 928/1001] Add a switch for config-independant cached functions


---

diff --git a/hubs/widgets/caching.py b/hubs/widgets/caching.py
index c531cc0..2476ca8 100644
--- a/hubs/widgets/caching.py
+++ b/hubs/widgets/caching.py
@@ -34,16 +34,22 @@ class CachedFunction(object):
     To call the function, instantiate the class and execute it. You may also
     call the :py:meth:`.get_data` method.
 
-    Args:
+    Attributes:
         instance (hubs.models.Widget): The widget instance.
+        invalidate_on_config_change (bool): ``True`` if the cached result
+            depends on the widget configuration, ``False`` otherwise. Defaults
+            to ``True``. E.g: the function retrieves a lot of raw data from an
+            external service, and config-dependant filtering is done in the
+            view calling the function.
     """
 
+    invalidate_on_config_change = True
+
     def __init__(self, instance):
         self.instance = instance
 
     def execute(self):
-        """
-        The function to cache.
+        """The function to cache.
 
         This is the main method, it must be implemented.
 
@@ -53,11 +59,10 @@ class CachedFunction(object):
         raise NotImplementedError
 
     def get_cache_key(self):
-        return "|".join([
-            str(self.instance.idx),
-            self.__class__.__name__,
-            json.dumps(self.instance.config),
-        ]).encode('utf-8')
+        key_elements = [str(self.instance.idx), self.__class__.__name__]
+        if self.invalidate_on_config_change:
+            key_elements.append(json.dumps(self.instance.config))
+        return "|".join(key_elements).encode('utf-8')
 
     def get_data(self):
         key = self.get_cache_key()
diff --git a/hubs/widgets/halp/functions.py b/hubs/widgets/halp/functions.py
index 662081d..0191710 100644
--- a/hubs/widgets/halp/functions.py
+++ b/hubs/widgets/halp/functions.py
@@ -25,6 +25,7 @@ class GetRequests(CachedFunction):
     them.
     """
 
+    invalidate_on_config_change = False
     TOPIC = "org.fedoraproject.prod.meetbot.meeting.item.help"
 
     def execute(self):

